# TensorFlow Base APIs

Tests of the `tf` , `tf.math` , `tf.nn` , `tf.signal` and `tf.strings` APIs.

IREE has three main backend
[targets](https://github.com/google/iree/tree/main/iree/compiler/Dialect/HAL/Target):
`vmvx` , `llvm` and `vulkan-spirv`. We also test TFLite in our infrastructure
for benchmarking purposes.

*Last Updated: 2020/12/8*

## End to end TensorFlow tests

|                                                           target                                                           |                    tflite                    |                     vmvx                     |                 vulkan-spirv                 |
|:--------------------------------------------------------------------------------------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|
|         [batch_norm_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/batch_norm_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|  [batch_to_space_nd_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/batch_to_space_nd_test.py)  | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [broadcast_to_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/broadcast_to_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [broadcasting_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/broadcasting_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|             [concat_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/concat_test.py)             | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [control_flow_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/control_flow_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|               [conv_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/conv_test.py)               | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|     [conv_transpose_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/conv_transpose_test.py)     | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [depth_conv_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/depth_conv_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|   [dynamic_mlp_relu_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/dynamic_mlp_relu_test.py)   | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [dynamic_mlp_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/dynamic_mlp_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|     [einsum_dynamic_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/einsum_dynamic_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [einsum_static_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/einsum_static_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [einsum_vector_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/einsum_vector_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|                [fft_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/fft_test.py)                | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|               [fill_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/fill_test.py)               | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|             [gather_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/gather_test.py)             | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [image_resize_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/image_resize_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [linspace_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/linspace_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [mandelbrot_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/mandelbrot_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
| [matrix_ops_dynamic_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/matrix_ops_dynamic_test.py) | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|  [matrix_ops_static_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/matrix_ops_static_test.py)  | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|   [quantization_dyn_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/quantization_dyn_test.py)   | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [quantization_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/quantization_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|              [range_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/range_test.py)              | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [resource_ops_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/resource_ops_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [ring_buffer_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/ring_buffer_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [scatter_update_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/scatter_update_test.py)     | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|  [simple_arithmetic_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/simple_arithmetic_test.py)  | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|    [simple_stateful_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/simple_stateful_test.py)    | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|     [sliding_window_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/sliding_window_test.py)     | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|  [space_to_batch_nd_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/space_to_batch_nd_test.py)  | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|            [strings_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/strings_test.py)            | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [tensorlist_test](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/tensorlist_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |

## End to end tests of tf.math functions with static dimensions

**Note:** To be thorough, these tests use high rank tensors and test int dtypes
where TensorFlow allows them to be used. Both of these choices
disproportionately affect TFLite coverage, and don't represent coverage for
simple use cases.

|                                                       target                                                      |                    tflite                    |                     vmvx                     |                 vulkan-spirv                 |
|:-----------------------------------------------------------------------------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|
|           [abs](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [accumulate_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [acos](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [acosh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [add](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [add_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [angle](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [argmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [argmin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [asin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [asinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [atan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [atan2](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [atanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i0](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i0e](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i1](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i1e](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [betainc](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [bincount](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [ceil](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|     [confusion_matrix](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [cos](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [cosh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [count_nonzero](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [cumprod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [cumsum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|   [cumulative_logsumexp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [digamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [divide](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [divide_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [erf](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [erfc](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [erfinv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [exp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [expm1](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [floor](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [floordiv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [floormod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [greater](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|      [greater_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [igamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [igammac](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [imag](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [in_top_k](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|    [invert_permutation](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)   | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [is_finite](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [is_inf](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [is_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|    [is_non_decreasing](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [is_strictly_increasing](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py) | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [lbeta](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [less](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [less_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [lgamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [log](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [log1p](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [log_sigmoid](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [log_softmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [logical_and](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [logical_not](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [logical_or](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [logical_xor](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [maximum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [minimum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [mod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [multiply](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|     [multiply_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [ndtri](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [negative](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [nextafter](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [not_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [polygamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [polyval](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [pow](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [real](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [reciprocal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|    [reciprocal_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [reduce_all](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [reduce_any](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|  [reduce_euclidean_norm](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [reduce_logsumexp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [reduce_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [reduce_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [reduce_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [reduce_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_std](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [reduce_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|     [reduce_variance](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [rint](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [round](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [rsqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [scalar_mul](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [segment_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [sigmoid](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [sign](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [sin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [sinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [sobol_sample](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [softmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [softplus](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [softsign](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [sqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [square](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|    [squared_difference](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)   | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [subtract](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [tan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [tanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [truediv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|   [unsorted_segment_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [unsorted_segment_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [unsorted_segment_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [unsorted_segment_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
| [unsorted_segment_sqrt_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py) | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [unsorted_segment_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [xdivy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [xlog1py](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [xlogy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [zero_fraction](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|           [zeta](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |

## End to end tests of tf.math functions with dynamic dimensions

|                                                       target                                                      |                    tflite                    |                     vmvx                     |                 vulkan-spirv                 |
|:-----------------------------------------------------------------------------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|
|           [abs](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [accumulate_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [acos](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [acosh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [add](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [add_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [angle](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [argmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [argmin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [asin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [asinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [atan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [atan2](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [atanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i0](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i0e](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i1](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [bessel_i1e](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [betainc](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [bincount](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [ceil](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|     [confusion_matrix](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [cos](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [cosh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [count_nonzero](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [cumprod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [cumsum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [cumulative_logsumexp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [digamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [divide](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [divide_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [erf](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [erfc](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [erfinv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [exp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [expm1](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [floor](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [floordiv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [floormod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [greater](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|      [greater_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [igamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [igammac](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [imag](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [in_top_k](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|    [invert_permutation](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)   | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [is_finite](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [is_inf](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [is_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|    [is_non_decreasing](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [is_strictly_increasing](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py) | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [lbeta](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [less](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [less_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [lgamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [log](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [log1p](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [log_sigmoid](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [log_softmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [logical_and](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [logical_not](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [logical_or](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [logical_xor](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [maximum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [minimum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [mod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [multiply](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|     [multiply_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [ndtri](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [negative](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [nextafter](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [not_equal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [polygamma](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [polyval](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [pow](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [real](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [reciprocal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|    [reciprocal_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_all](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_any](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [reduce_euclidean_norm](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [reduce_logsumexp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [reduce_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [reduce_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_std](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [reduce_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [reduce_variance](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [rint](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [round](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [rsqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|        [scalar_mul](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [segment_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [segment_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [sigmoid](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [sign](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [sin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [sinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|       [sobol_sample](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [softmax](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [softplus](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [softsign](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [sqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [square](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|    [squared_difference](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)   | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [subtract](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [tan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)           | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|           [tanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|         [truediv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|   [unsorted_segment_max](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [unsorted_segment_mean](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [unsorted_segment_min](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|  [unsorted_segment_prod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
| [unsorted_segment_sqrt_n](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py) | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [unsorted_segment_sum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [xdivy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [xlog1py](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [xlogy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|      [zero_fraction](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|           [zeta](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |

## End to end tests of tf.math functions with complex numbers

|                                                      target                                                     |                    tflite                    |                     vmvx                     |                 vulkan-spirv                 |
|:---------------------------------------------------------------------------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|:--------------------------------------------:|
|          [abs](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [add](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [angle](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [asinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [atanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [conj](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [cos](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [cosh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [count_nonzero](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [cumprod](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [cumsum](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [divide](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [divide_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [exp](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [expm1](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [imag](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|      [l2_normalize](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="failure-table-element">✗</span> |
|          [log](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [log1p](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [multiply](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|    [multiply_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [negative](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [pow](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [real](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|       [reciprocal](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|   [reciprocal_no_nan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)   | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
| [reduce_euclidean_norm](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py) | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|       [reduce_std](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)      | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|    [reduce_variance](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)    | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [rsqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [sigmoid](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [sign](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [sin](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [sinh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [sqrt](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [square](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|   [squared_difference](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)  | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|        [subtract](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)       | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|          [tan](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)          | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|          [tanh](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [truediv](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="success-table-element">✓</span> | <span class="success-table-element">✓</span> |
|         [xdivy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|        [xlog1py](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)        | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|         [xlogy](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)         | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
|     [zero_fraction](https://github.com/google/iree/tree/main/integrations/tensorflow/e2e/math/math_test.py)     | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> | <span class="failure-table-element">✗</span> |
