// Tests printing and parsing of comparison ops.

// RUN: iree-opt -split-input-file -pass-pipeline='vm.module(iree-convert-vm-to-emitc)' %s | IreeFileCheck %s

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_eq_f32o
  vm.func @cmp_eq_f32o(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_eq_f32o"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.eq.f32.o %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_eq_f32u
  vm.func @cmp_eq_f32u(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_eq_f32u"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.eq.f32.u %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_ne_f32o
  vm.func @cmp_ne_f32o(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_ne_f32o"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.ne.f32.o %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_ne_f32u
  vm.func @cmp_ne_f32u(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_ne_f32u"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.ne.f32.u %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_lt_f32o
  vm.func @cmp_lt_f32o(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_lt_f32o"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.lt.f32.o %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_lt_f32u
  vm.func @cmp_lt_f32u(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_lt_f32u"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.lt.f32.u %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_lte_f32o
  vm.func @cmp_lte_f32o(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_lte_f32o"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.lte.f32.o %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_lte_f32u
  vm.func @cmp_lte_f32u(%arg0 : f32, %arg1 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_lte_f32u"(%arg0, %arg1) : (f32, f32) -> i32
    %0 = vm.cmp.lte.f32.u %arg0, %arg1 : f32
    vm.return
  }
}

// -----

vm.module @module {
  // CHECK-LABEL: vm.func @cmp_nan_f32
  vm.func @cmp_nan_f32(%arg0 : f32) -> i32 {
    // CHECK-NEXT: %0 = emitc.call "vm_cmp_nan_f32"(%arg0) : (f32) -> i32
    %0 = vm.cmp.nan.f32 %arg0 : f32
    vm.return
  }
}
